package com.zksy.web.controller.basicData;

import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmDishonestExecutor;
import com.zksy.system.basicData.service.CrmDishonestExecutorService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 司法涉诉-失信被执行人Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmDishonestExecutor")
@Api(tags = "司法涉诉-失信被执行人", description = "司法涉诉-失信被执行人desc")
public class CrmDishonestExecutorController extends BaseController{

    @Autowired
    private CrmDishonestExecutorService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "司法涉诉-失信被执行人搜索getById")
    public CrmDishonestExecutor getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "司法涉诉-失信被执行人分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "司法涉诉-失信被执行人查询所有")
    public List<CrmDishonestExecutor> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增司法涉诉-失信被执行人
     */
    @PostMapping("/save")
    @ApiOperation(value = "司法涉诉-失信被执行人新增")
    @Log(title = "新增司法涉诉-失信被执行人", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmDishonestExecutor crmDishonestExecutor) {
        return service.save(crmDishonestExecutor);
    }

    /**
     * 修改司法涉诉-失信被执行人
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "司法涉诉-失信被执行人修改")
    @Log(title = "修改司法涉诉-失信被执行人", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmDishonestExecutor crmDishonestExecutor) {
        return service.updateById(crmDishonestExecutor);
    }

    /**
     * 导入司法涉诉-失信被执行人
     */
    @ApiOperation("司法涉诉-失信被执行人导入")
    @Log(title = "司法涉诉-失信被执行人", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmDishonestExecutor> crmDishonestExecutorAll = service.list();
            List<CrmDishonestExecutor> list = ExcelUtils.readMultipartFile(file, CrmDishonestExecutor.class,CrmDishonestExecutor.class.getDeclaredFields().length - 2);
            if(crmDishonestExecutorAll != null && crmDishonestExecutorAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("司法涉诉-失信被执行人导出")
    @Log(title = "司法涉诉-失信被执行人", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmDishonestExecutor> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"司法涉诉-失信被执行人",wrapperList,CrmDishonestExecutor.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "司法涉诉-失信被执行人", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除司法涉诉-失信被执行人", notes = "删除司法涉诉-失信被执行人")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"司法涉诉-失信被执行人模板");
    }
}

